If WScript.Arguments.Count <> 1 Then
  WScript.Echo "Usage cscript /nologo delete_policy_by_name.vbs <name>"
  WScript.Quit(1)
End If

Dim policyName
policyName = WScript.Arguments(0)

Dim shell
Set shell = WScript.CreateObject("WScript.Shell")

Dim amsCnn, cardsCnn
Set amsCnn = WScript.CreateObject("ADODB.Connection")
amsCnn.ConnectionString = ReadConnectionString("acronis_cms")
amsCnn.Open

Set cardsCnn = WScript.CreateObject("ADODB.Connection")
cardsCnn.ConnectionString = ReadConnectionString("acronis_cms_cards")
cardsCnn.Open

Dim query
query = "SELECT CAST(P.ID AS varchar(50)) PolicyID " &_
"FROM Policy P WHERE P.Name = '" & policyName & "'"
Set rs = amsCnn.Execute(query, , adCmdText)

If rs.EOF Then
  WScript.Echo("No backup policy named '" & policyName & "' is found.")
  WScript.Quit(2)
End If

Dim policyID
policyID = rs("PolicyID")

Dim insert
insert = "INSERT INTO " &_
"OutgoingCards (Machine, Verb, ObjectID, ObjectType, ObjectData, HasProtectedPart) "

Dim from
from = "FROM AttachedMachines " &_
"WHERE MachineID IN " &_
"(SELECT M.ID MachineID " &_
"FROM acronis_cms.dbo.Machine M " &_
"INNER JOIN acronis_cms.dbo.Instance I ON M.ID = I.HostID " &_
"INNER JOIN acronis_cms.dbo.InstancePolicy IP ON I.ID = IP.OwnerID " &_
"WHERE IP.PolicyID = '" & policyID & "')"

Call cardsCnn.Execute(insert &_
  "SELECT MachineID Machine, 4 Verb, BackupPlanID ObjectID, 6 ObjectType, NULL ObjectData, 0 HasProtectedPart " &_
  "FROM AttachedMachines AM INNER JOIN acronis_cms.dbo.Machine M ON AM.MachineID = M.ID " &_
  "INNER JOIN acronis_cms.dbo.Instance I ON M.ID = I.HostID " &_
  "INNER JOIN acronis_cms.dbo.InstancePolicy IP ON I.ID = IP.OwnerID " &_
  "WHERE IP.PolicyID = '" & policyID & "'")
  
Call cardsCnn.Execute(insert & "SELECT MachineID Machine, 4 Verb, '" & policyID & "' ObjectID, 4 ObjectType, NULL ObjectData, 0 HasProtectedPart " & from)

WScript.Echo("Deleting policy named '" & policyName & "'")
Call amsCnn.Execute("DELETE FROM InstancePolicy WHERE PolicyID = '" & policyID & "'", adCmdText)
Call amsCnn.Execute("DELETE FROM GroupPolicy WHERE PolicyID = '" & policyID & "'", adCmdText)
Call amsCnn.Execute("DELETE FROM Policy WHERE ID = '" & policyID & "'", adCmdText)
WScript.Echo("Policy named '" & policyName & "' has been successfully deleted.")

Function ReadConnectionString(dbName)
  On Error Resume Next
  ReadConnectionString = shell.RegRead("HKLM\SOFTWARE\Acronis\AMS\ConnectionStrings\" & dbName)
  If ReadConnectionString = "" Then
    ReadConnectionString = shell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Acronis\AMS\ConnectionStrings\" & dbName)
  End If
  If ReadConnectionString = "" Then
    WScript.Echo("ERROR: Connection string to AMS database '" & dbName & "' cannot be found in the registry." &_
      " Most probably AMS is not installed on local machine or installation is corrupt.")
    WScript.Quit(3)
  End If
End Function
